<?php
/**
 * FlickrImport
 *
 * Import your flickr stream into your pixelpost stream.
 *
 * IMPORTANT :
 *
 * This Pixelpost Addon include a modified part of Phlickr
 * produced by Andrew Morton <drewish@katherinehouse.com>
 * (@link http://sourceforge.net/projects/phlickr/)
 * which is under LGPL license.
 *
 * This Pixelpost addon is heavily inspired by Pixelpost Importr addon produced
 * by Christian Cueni <chrigu@trivialview.ch> (@link http://www.trivialview.ch)
 * which is under GPL license.
 *
 * REQUIREMENTS :
 *
 * - PHP CURL library installed
 * - SimpleXml library installed
 *
 * LICENCE :
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * @version 0.03
 * @author Alban Leroux <seza@paradoxal.org>
 * @see http://www.paradoxal.org/blog/
 * @license GPL License: http://www.gnu.org/copyleft/gpl.html
 */

// if options are modified
if ($_GET['action'] == 'edit')
{
    // get the modified data
    $conf['photo.size']           = $_POST['FlickrImport_photosize'];
    $conf['photo.date']           = $_POST['FlickrImport_photodate'];
    $conf['photo.tags']           = $_POST['FlickrImport_phototags'];
    $conf['photo.resize']         = $_POST['FlickrImport_photoresize'];
    $conf['photo.resize.size']    = $_POST['FlickrImport_photoresizesize'];
    $conf['photo.resize.quality'] = $_POST['FlickrImport_photoresizequality'];
    $conf['photo.link']           = $_POST['FlickrImport_photolink'];
    $conf['photo.link.text']      = $_POST['FlickrImport_photolinktext'];
    $conf['photo.link.format']    = $_POST['FlickrImport_photolinkformat'];
    $conf['thumbs.size']          = $_POST['FlickrImport_thumbssize'];
    $conf['comments']             = $_POST['FlickrImport_comments'];
    $conf['comments.publish']     = $_POST['FlickrImport_commentspublish'];
    $conf['comments.html']        = $_POST['FlickrImport_commentshtml'];
}

// prepare options
$imageSizeOriginal  = $imageSize1024    = $imageSize500    = '';
$imageDateTaken     = $imageDateUpload  = '';
$imageTagsYes       = $imageTagsNo      = '';
$imageResizeYes     = $imageResizeNo    = '';
$imageLinkYes       = $imageLinkNo      = '';
$thumbsSizeThumb    = $thumbsSizeSquare = $thumbsSizePixel = '';
$commentsYes        = $commentsNo       = '';
$commentsPublishYes = $commentPublishNo = '';
$commentsHtmlYes    = $commentsHtmlNo   = '';

switch ($conf['photo.size'])
{
    case 'original' : $imageSizeOriginal = ' checked="checked"'; break;
    case '1024'     : $imageSize1024     = ' checked="checked"'; break;
    case '500'      : $imageSize500      = ' checked="checked"'; break;
    default         : $imageSizeOriginal = ' checked="checked"'; $conf['photo.size'] = 'original'; break;
}

switch ($conf['photo.date'])
{
    case 'taken'  : $imageDateTaken  = ' checked="checked"'; break;
    case 'upload' : $imageDateUpload = ' checked="checked"'; break;
    default       : $imageDateTaken  = ' checked="checked"'; $conf['photo.date'] = 'taken'; break;
}

switch ($conf['photo.tags'])
{
    case 'yes' : $imageTagsYes = ' checked="checked"'; break;
    case 'no'  : $imageTagsNo  = ' checked="checked"'; break;
    default    : $imageTagsYes = ' checked="checked"'; $conf['photo.tags'] = 'yes'; break;
}

switch ($conf['photo.resize'])
{
    case 'yes' : $imageResizeYes = ' checked="checked"'; break;
    case 'no'  : $imageResizeNo  = ' checked="checked"'; break;
    default    : $imageResizeNo  = ' checked="checked"'; $conf['photo.resize'] = 'no'; break;
}

switch ($conf['photo.link'])
{
    case 'no'  : $imageLinkNo  = ' checked="checked"'; break;
    case 'yes' : $imageLinkYes = ' checked="checked"'; break;
    default    : $imageLinkNo  = ' checked="checked"'; $conf['photo.link'] = 'no'; break;
}

switch ($conf['thumbs.size'])
{
    case 'thumbs' : $thumbsSizeThumb  = ' checked="checked"'; break;
    case 'square' : $thumbsSizeSquare = ' checked="checked"'; break;
    case 'pixel'  : $thumbsSizePixel  = ' checked="checked"'; break;
    default       : $thumbsSizeThumb  = ' checked="checked"'; $conf['thumbs.size'] = 'thumbs'; break;
}

switch ($conf['comments'])
{
    case 'yes'         : $commentsYes    = ' checked="checked"'; break;
    case 'no'          : $commentsNo     = ' checked="checked"'; break;
    default            : $commentsYes    = ' checked="checked"'; $conf['comments'] = 'yes'; break;
}

switch ($conf['comments.publish'])
{
    case 'yes' : $commentsPublishYes = ' checked="checked"'; break;
    case 'no'  : $commentsPublishNo  = ' checked="checked"'; break;
    default    : $commentsPublishYes = ' checked="checked"'; $conf['comments.publish'] = 'no'; break;
}

switch ($conf['comments.html'])
{
    case 'yes' : $commentsHtmlYes = ' checked="checked"'; break;
    case 'no'  : $commentsHtmlNo  = ' checked="checked"'; break;
    default    : $commentsHtmlYes = ' checked="checked"'; $conf['comments.html'] = 'no'; break;
}

// if options are modified and now filtered
if ($_GET['action'] == 'edit')
{
    // update the options
    if (FlickrImport::setOptions($conf))
        $eMessage = '<p style="color:green;font-weight:bold;">Options are updated !</p>';
    else
        $eMessage = '<p style="color:red;font-weight:bold;">Update Failed !</p>';

    // if no photosets are selected
    if (!isset($_POST['FlickrImport_photosets'])) $_POST['FlickrImport_photosets'] = array();
    // if no tags are selected
    if (!isset($_POST['FlickrImport_tags']))      $_POST['FlickrImport_tags'] = array();

    // update the photoset to sync
    FlickrImport::updateSyncPhotoset($_POST['FlickrImport_photosets']);
    // update the tags to blacklist
    FlickrImport::updateNotSyncTags($_POST['FlickrImport_tags']);
}

// get the user info
try
{
    $user = new Phlickr_User($api, $api->getUserId());

    $infoMessage = '<p>Connected to the account : <a href="' . $user->buildUrl() . '">' . $user->getRealname() . '</a></p>';
}
catch(Exception $e)
{
    $infoMessage = '<p style="color:red; font-weight:bold">Fail to connect at ' . $api->getUserId() . ' this user doesn\'t exist !</p>';
}

// load the photoset to sync
$photosetSync = FlickrImport::getSyncPhotoset();
// load the tags to blacklist
$tagsSync     = FlickrImport::getNotSyncTags();
?>

<div class="jcaption">Account</div>
<div class="content">
    <?php echo $infoMessage; ?>
</div>

<div class="jcaption">Synchronize Your Flickr account</div>
<div class="content">
    <p>
        <a href="<?php echo $webUrl; ?>addons/<?php echo urlencode($me); ?>/sync.php" target="_blank">Click here to import your Flickr's photo</a>
        <br />
        or add the <em><?php echo realpath(dirname(__FILE__)) . DIRECTORY_SEPARATOR . $me . DIRECTORY_SEPARATOR; ?>sync.php</em> to your crontab.
    </p>
</div>

<div class="jcaption">Options</div>
<div class="content">
    <?php echo $eMessage; ?>
    <form method="post" action="<?php echo $baseUrl; ?>&amp;action=edit" accept-charset="UTF-8">

        <table width="100%">
        <tr>
            <td valign="top">
                <p><strong>Choose the Photos size to download:</strong></p>
                <p>
                    <input type="radio" name="FlickrImport_photosize" value="original"<?php echo $imageSizeOriginal; ?> />
                    Use Flickr Original
                    <br />
                    <input type="radio" name="FlickrImport_photosize" value="1024"<?php echo $imageSize1024; ?> />
                    Use Flickr 1024px on longer side
                    <br />
                    <input type="radio" name="FlickrImport_photosize" value="500"<?php echo $imageSize500; ?> />
                    Use Flickr 500px on longer size
                </p>

                <p>
                    <strong>
                        Photo resizing:
                        <input type="radio" name="FlickrImport_photoresize" value="yes"<?php echo $imageResizeYes; ?> /> Yes
                        <input type="radio" name="FlickrImport_photoresize" value="no"<?php echo $imageResizeNo; ?> /> No
                    </strong>
                </p>
                <p>
                    <input type="text" size="4" name="FlickrImport_photoresizesize" value="<?php echo $conf['photo.resize.size']; ?>" />
                    The maximum longer side size in pixel
                    <br />
                    <input type="text" size="2" name="FlickrImport_photoresizequality" value="<?php echo $conf['photo.resize.quality']; ?>" />
                    The quality of compression (less than 60 is better compression, more than 80 is better image quality).
                </p>

                <p><strong>Choose the Thumbnails model:</strong></p>
                <p>
                    <input type="radio" name="FlickrImport_thumbssize" value="thumbs"<?php echo $thumbsSizeThumb; ?> />
                    Use Flickr Thumbnails - 100px on longer side
                    <br />
                    <input type="radio" name="FlickrImport_thumbssize" value="square"<?php echo $thumbsSizeSquare; ?> />
                    Use Flickr Square - 75px cropped image
                    <br />
                    <input type="radio" name="FlickrImport_thumbssize" value="pixel"<?php echo $thumbsSizePixel; ?> />
                    Let Pixelpost generate thumbnail
                </p>

                <p>
                    <strong>
                        Append to the description a flickr photo page link:
                        <input type="radio" name="FlickrImport_photolink" value="yes"<?php echo $imageLinkYes; ?> /> Yes
                        <input type="radio" name="FlickrImport_photolink" value="no"<?php echo $imageLinkNo; ?> /> No
                    </strong>
                </p>
                <p>
                    <input type="text" size="30" name="FlickrImport_photolinktext" value="<?php echo $conf['photo.link.text']; ?>" />
                    The text appears in the link (ex : see it on Flickr).
                    <br />
                    <input type="text" size="30" name="FlickrImport_photolinkformat" value="<?php echo $conf['photo.link.format']; ?>" />
                    The Link format in description. (ex : [ %s ] )
                    <br />
                    With both example link look like this : [ <a href="#" onclick="return false;">see it on Flickr</a> ]
                </p>

                <p><strong>Choose the Photos date:</strong></p>
                <p>
                    <input type="radio" name="FlickrImport_photodate" value="taken"<?php echo $imageDateTaken; ?> />
                    Use Flickr date taken - photo will be ordered by taken date.
                    <br />
                    <input type="radio" name="FlickrImport_photodate" value="upload"<?php echo $imageDateUpload; ?> />
                    Use Flickr date upload - photo will be ordered identical as Flickr.
                </p>

                <p>
                    <strong>Import photo tags:</strong>
                    <input type="radio" name="FlickrImport_phototags" value="yes"<?php echo $imageTagsYes; ?> /> Yes
                    <input type="radio" name="FlickrImport_phototags" value="no"<?php echo $imageTagsNo; ?> /> No
                </p>

                <p>
                    <strong>
                        Import photo's comments:
                        <input type="radio" name="FlickrImport_comments" value="yes"<?php echo $commentsYes; ?> /> Yes
                        <input type="radio" name="FlickrImport_comments" value="no"<?php echo $commentsNo; ?> /> No
                    </strong>
                </p>
                <p>
                    Publish directly comments:
                    <input type="radio" name="FlickrImport_commentspublish" value="yes"<?php echo $commentsPublishYes; ?> /> Yes
                    <input type="radio" name="FlickrImport_commentspublish" value="no"<?php echo $commentsPublishNo; ?> /> No
                    <br />
                    Strip the HTML tags in comments:
                    <input type="radio" name="FlickrImport_commentshtml" value="yes"<?php echo $commentsHtmlYes; ?> /> Yes
                    <input type="radio" name="FlickrImport_commentshtml" value="no"<?php echo $commentsHtmlNo; ?> /> No
                </p>
                <p>
                    <input type="submit" value="Save" />
                </p>
            </td>
            <td  valign="top">
                <p><strong>Choose the Flickr photoset you want import:</strong></p>
                <p>
                <?php
                // list of photoset
                foreach($user->getPhotosetList()->getPhotosets() as $photoset)
                {
                    $pId    = $photoset->getId();
                    $count  = $photoset->getPhotoCount();
                    $title  = $photoset->getTitle();
                    $url    = $photoset->buildUrl();
                    $isSync = (isset($photosetSync[$pId]) ? ' checked="checked"' : '');

                    echo '<input type="checkbox" name="FlickrImport_photosets[]" value="' . $pId . '"' . $isSync . ' /> '
                       . '<a href="' . $url . '" taget="_blank">' . $title . '</a> (' . $count . ' photos)<br />';
                }
                ?>
                </p>
                <p><strong>Choose the tag you wouldn't import:</strong></p>
                <p>
                <?php
                // list of photoset
                foreach($user->getTags() as $tag)
                {
                    $isListed = (isset($tagsSync[$tag]) ? ' checked="checked"' : '');

                    echo '<input type="checkbox" name="FlickrImport_tags[]" value="' . $tag . '"' . $isListed . ' /> ' . $tag . '<br />';
                }
                ?>
                </p>
            </td>
        </tr>
    </table>
    </form>
</div>
